// *************************************************************************************************
//
// Horde3D
//   Next-Generation Graphics Engine
// ---------------------------------
// Copyright (C) 2006 Nicolas Schulz
//
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//
// *************************************************************************************************

#pragma once

#ifndef DLL
#	if defined( WIN32 ) || defined( _WINDOWS )
#		define DLL extern "C" __declspec( dllimport )
#	else
#		define DLL
#	endif
#endif


namespace Horde3DUtils
{
	DLL bool initOpenGL( int hDC );
	DLL void releaseOpenGL();
	DLL void swapBuffers();

	DLL bool loadResourcesFromDisk( const char *contentDir );
	DLL bool dumpMessages();
	
	DLL void showText( const char *text, float x, float y, float size, 
					   unsigned int layer, unsigned int fontMatRes );

	DLL void freeMem( char **ptr );
	DLL bool createTGAImage( const unsigned char *pixels, unsigned int width, unsigned int height,
							 unsigned int bpp, char **outData, unsigned int *outSize );
};
