// *************************************************************************************************
//
// Horde3D
//   Next-Generation Graphics Engine
//
// Sample Application
// ---------------------------------
// Copyright (C) 2006 Nicolas Schulz
//
//
// This sample source file is not covered by the LGPL as the rest of the SDK
// and may be used without any restrictions
//
// *************************************************************************************************

#pragma once

#include "Horde3D.h"
#include <sstream>
using namespace std;


class Application
{
private:

	bool			_keys[256];
	float			_x, _y, _z, _rx, _ry;	// Viewer position and orientation
	float			_velocity;				// Velocity for movement
	float			_curFPS, _timer;
	stringstream	_fpsText;

	bool			_freeze, _showFPS, _debugViewMode;
	float			_animTime, _weight;
	
	// Engine objects
	ResHandle		_fontMatRes, _logoMatRes;
	NodeHandle		_knight, _particleSys;

	void keyHandler();

public:
	
	Application();
	
	bool init();
	void mainLoop( float fps );
	void release();
	void resize( int width, int height );

	void keyPressEvent( int keyCode );
	void keyStateChange( unsigned char key, bool state ) { _keys[key] = state; }
	void mouseMoveEvent( float dX, float dY );
};
