// *************************************************************************************************
//
// Horde3D
//   Next-Generation Graphics Engine
// --------------------------------------
// Copyright (C) 2006-2007 Nicolas Schulz
//
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//
// *************************************************************************************************

#pragma once

#include "egScene.h"


class CameraNode : public SceneNode
{
private:

	Matrix4f		_invTrans;
	float			_frustLeft, _frustRight, _frustBottom, _frustTop;
	float			_frustNear, _frustFar;

	void onUpdate();

public:
	
	CameraNode( const string &name );
	~CameraNode();
	
	float getParam( CameraNodeParams::List param );
	bool setParam( CameraNodeParams::List param, float value );

	void setupViewParams( float fov, float aspect, float near, float far );

	void genFrustum( Frustum &frustum );

	friend class Renderer;
};

