// *************************************************************************************************
//
// Horde3D
//   Next-Generation Graphics Engine
// --------------------------------------
// Copyright (C) 2006-2007 Nicolas Schulz
//
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//
// *************************************************************************************************

#include "egIntegrationLib.h"

#include "egSingleton.h"


NodeAttFactoryFunc NodeAttachment::getFactory()
{
	return TheSceneManager::instance().getAttFactoryPtr();
}


void NodeAttachment::setFactory( NodeAttFactoryFunc func )
{
	TheSceneManager::instance().getAttFactoryPtr() = func;	
}


NodeAttCollectorFunc NodeAttachment::getCollector()
{
	return TheSceneManager::instance().getAttCollectorPtr();
}


void NodeAttachment::setCollector( NodeAttCollectorFunc func )
{
	TheSceneManager::instance().getAttCollectorPtr() = func;	
}


NodeAttachment *NodeAttachment::getFromNode( unsigned int node )
{
	SceneNode *sn = TheSceneManager::instance().resolveNodeHandle( node );
	if( sn != 0x0 ) return sn->getAttachment();
	else return 0x0;
}


NodeAttachment::NodeAttachment( unsigned int node )
{
	_node = node;
	SceneNode *sn = TheSceneManager::instance().resolveNodeHandle( _node );
	if( sn != 0x0 ) sn->setAttachment( this );
}


NodeAttachment::~NodeAttachment()
{
	SceneNode *sn = TheSceneManager::instance().resolveNodeHandle( _node );
	if( sn != 0x0 ) sn->setAttachment( 0x0 );
}


void NodeAttachment::updateSceneGraph()
{
	TheSceneManager::instance().getRootNode().update();
}

