// *************************************************************************************************
//
// Horde3D
//   Next-Generation Graphics Engine
// --------------------------------------
// Copyright (C) 2006-2007 Nicolas Schulz
//
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//
// *************************************************************************************************

#pragma once

#include "utPlatform.h"


typedef void (*NodeAttFactoryFunc)( unsigned int node, const char *attachmentString );
typedef void (*NodeAttCollectorFunc)( unsigned int node );


#ifndef DLLEXP_CLASS
#	ifdef PLATFORM_WIN
#		define DLLEXP_CLASS __declspec( dllexport )
#	else
#		define DLLEXP_CLASS
#	endif
#endif


class DLLEXP_CLASS NodeAttachment
{
protected:
	
	unsigned int	_node;

public:

	static NodeAttFactoryFunc getFactory();
	static void setFactory( NodeAttFactoryFunc func );
	static NodeAttCollectorFunc getCollector();
	static void setCollector( NodeAttCollectorFunc func );
	static NodeAttachment *getFromNode( unsigned int node );
	
	NodeAttachment( unsigned int node );
	virtual ~NodeAttachment();
	virtual void onUpdate() {}

	void updateSceneGraph();

	friend class SceneNode;
};
