// *************************************************************************************************
//
// Horde3D
//   Next-Generation Graphics Engine
// --------------------------------------
// Copyright (C) 2006-2007 Nicolas Schulz
//
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//
// *************************************************************************************************

#pragma once

#include "egScene.h"

class MaterialResource;


class LightNode : public SceneNode
{
private:

	Matrix4f			_invTrans;
	Vec3f				_absPos, _spotDir;

	MaterialResource	*_materialRes;
	string				_lightingContext, _shadowContext;
	float				_radius, _fov;
	float				_diffCol_R, _diffCol_G, _diffCol_B;
	unsigned int		_shadowMapCount;
	float				_shadowSplitLambda, _shadowMapBias;

	void onUpdate();

public:
	
	LightNode( const string &name, unsigned int materialRes,
			   const string &lightingContext, const string &shadowContext );
	~LightNode();
	
	float getParam( LightNodeParams::List param );
	bool setParam( LightNodeParams::List param, float value );

	void genFrustum( Frustum &frustum );
	void calcScreenSpaceAABB( const Matrix4f &mat, float &x, float &y, float &w, float &h );

	friend class Renderer;
};

