// *************************************************************************************************
//
// Horde3D
//   Next-Generation Graphics Engine
// --------------------------------------
// Copyright (C) 2006-2007 Nicolas Schulz
//
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//
// *************************************************************************************************

#pragma once

#include "egResource.h"

class ShaderResource;
class TiXmlDocument;


struct TexUnit
{
	unsigned int	unit;
	Resource		*texRes;
	

	TexUnit()
	{
		unit = 0;
		texRes = 0x0;
	}
};


struct Uniform
{
	string			name;
	float			values[4];	


	Uniform()
	{
		values[0] = 0; values[1] = 0; values[2] = 0; values[3] = 0;
	}
};


class MaterialResource : public Resource
{
private:

	string                      _class;
	ShaderResource				*_shaderRes;
	vector< TexUnit >			_texUnits;
	vector< Uniform >			_uniforms;

	bool raiseError( TiXmlDocument *doc );

public:

	static void initResType() {};
	static void releaseResType() {};
	
	MaterialResource( const string &name, unsigned int flags );
	~MaterialResource();
	
	void initDefault();
	void release();
	bool load( const char *data, unsigned int size );
	bool setUniform( const string &name, float a, float b, float c, float d );
	bool isOfClass( const string &theClass );

	friend class ResourceManager;
	friend class Renderer;
	friend class MeshNode;
};
