// *************************************************************************************************
//
// Horde3D
//   Next-Generation Graphics Engine
// --------------------------------------
// Copyright (C) 2006-2007 Nicolas Schulz
//
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//
// *************************************************************************************************

#pragma once

#include "egCom.h"
#include "egScene.h"
#include "egResource.h"
#include "egRenderer.h"
#include "egPipeline.h"


class TheEngineConfig		// Singleton factory for EngineConfig
{
private:

	static EngineConfig *_instance;

public:

	static EngineConfig &instance()
	{
		if( _instance == 0x0 ) _instance = new EngineConfig();
		return *_instance;
	}

	static void destroyInstance();
};



class TheEngineLog			// Singleton factory for EngineLog
{
private:

	static EngineLog *_instance;

public:

	static EngineLog &instance()
	{
		if( _instance == 0x0 ) _instance = new EngineLog();
		return *_instance;
	}

	static void destroyInstance();
};



class TheSceneManager
{
private:

	static SceneManager *_instance;

public:

	static SceneManager &instance()
	{
		if( _instance == 0x0 ) _instance = new SceneManager();
		return *_instance;
	}

	static void destroyInstance();
};



class TheResourceManager
{
private:

	static ResourceManager *_instance;

public:

	static ResourceManager &instance()
	{
		if( _instance == 0x0 ) _instance = new ResourceManager();
		return *_instance;
	}

	static void destroyInstance();
};



class TheRenderer
{
private:

	static Renderer *_instance;

public:

	static Renderer &instance()
	{
		if( _instance == 0x0 ) _instance = new Renderer();
		return *_instance;
	}

	static void destroyInstance();
};


class ThePipeline
{
private:

	static Pipeline *_instance;

public:

	static Pipeline &instance()
	{
		if( _instance == 0x0 ) _instance = new Pipeline();
		return *_instance;
	}

	static void destroyInstance();
};
